<?php
// Fonction du simulateur de robot
// 1. URL à tester
// 2. Activer ou non la colorisation du code (true/false)
// 3. Numéroter ou non les lignes de codes (true/false)
function spiderSimulator($page = '', $colorisation = false, $numerotation = false) {
	// Ajout du protocole s'il est manquant
	if(!preg_match("#^https?://#iU", $page)) {
        $page = "http://".$page;
    }

    /*=========================*/
    /*=== Version avec CURL ===*/
    /*=========================*/
	/*// Activation de cURL
    $url = curl_init($page);

	// Options de cURL (retour des données et des en-têtes)
    curl_setopt($url, CURLOPT_HEADER, true);
    curl_setopt($url, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($url, CURLOPT_SSL_VERIFYPEER, false);
	
	// Récupération du contenu
	$contenu = curl_exec($url);
	$code = '';

	// Fermeture de cURL
	curl_close($url);*/
	
	/*=========================*/
    /*=== Version classique ===*/
    /*=========================*/
	// On initialise le code
	$code = '';

	// Liste les entêtes
	$headers = get_headers($page);
	foreach($headers as $header) {
		// Si la colorisation est active
		if($colorisation == true) {
			$code.= '<span style="color:#444">'.$header."</span><br/>\n";
		} else {
			$code.= $header."<br/>\n";
		}
	}

	// Lit le contenu
	$contenu = file_get_contents($page);

	// Découpage du contenu en ligne
	$lignes = explode("\n", $contenu);

	// Afficher ligne par ligne
	foreach($lignes as $num => $ligne) {
		// Affichage optionnel du numéro de ligne
		if($numerotation == true) {
			$code .= '<span style="display:inline-block; width:40px; color:green">'.$num."</span>";
		}
		
		// Affichage des balises HTML
		$ligne = htmlspecialchars($ligne);
		
		// Si la colorisation est active
		if($colorisation == true) {
			// Colorisation des attributs et valeurs d'attributs
			$regex = "#(.*)([a-zA-Z0-9:-]+)(=)(&quot;|&apos;|[\'])([^\']+)(&quot;|&apos;|[\'])([/> ]|&gt;)#iU";
			$replace = "$1<span style='color:#FB5758'>$2$3</span><span style='color:#FB5758'>$4</span><span style='color:#999'>$5</span><span style='color:#FB5758'>$6</span>$7";
			$ligne = preg_replace($regex, $replace, $ligne);
			
			// Colorisation des balises
			$regex = "#(&lt;/?[a-zA-Z0-9!]+[ ])#iU";
			$replace = "<span style='color:#0089E2'>$1</span>";
			$ligne = preg_replace($regex, $replace, $ligne);
			$regex = "#(&lt;/?[a-zA-Z0-9]+/?&gt;)#iU";
			$replace = "<span style='color:#0089E2'>$1</span>";
			$ligne = preg_replace($regex, $replace, $ligne);
			$regex = "#(/?&gt;)#iU";
			$replace = "<span style='color:#0089E2'>$1</span>";
			$ligne = preg_replace($regex, $replace, $ligne);
		}
		
		$code .= $ligne;
		$code .= "<br/>\n";
	}
	
	// On force l'affichage en UTF-8
	preg_match("#charset=['\"]?([a-zA-Z0-9-]+)['\"]?[^a-zA-Z0-9-]#iU", $code, $result);
	if(!empty($result)) {
		$encodage = strtolower($result[1]);
		if($encodage != 'utf-8') {
			$code = mb_convert_encoding($code, "UTF-8", $encodage);
		}
	}

	// Affiche le code source complet
	echo $code;
}
?>

<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8"/>
<title>Spider Simulator</title>
<style type="text/css"/>
* {margin:0; padding:0; font-size:100%}
#formulaire {background:#eee; padding:1%}
#formulaire h1 {font-size:1.8em; color:#004C54; margin-bottom:1em}
.bloc {margin-bottom:.8em}
.bloc label {display:block; font-weight:bold; padding:.1em;}
.bloc input, .bloc select {display:block; float:left; margin-right:1em; padding:.1em; border:1px solid #ccc;}
.bloc input {width:250px;}
.bloc select {width:72px; text-align:center;}
#resultat {background:#fafafa; padding:1em}
#resultat h2 {font-size:1.3em; color:#198A95; margin-bottom:.8em}
#bouton input {padding:.2em .5em; font-weight:bold; border:1px solid #ccc; background:#fff; color:#004C54}
#bouton input:hover {background:#004C54; color:#fff}
</style>
</head>

<body>
<div id="formulaire">
	<h1>Simulateur de robot d'indexation</h1>
	<form method="post">
		<div class="bloc">
		<input type="text" name="url" value="<?php if(isset($_POST['url'])) { echo $_POST['url']; } ?>"/>
		<label for="url">URL à tester</label>
		</div>
		
		<div class="bloc">
		<select name="col">
			<option value="0" <?php if(isset($_POST['col']) && $_POST['col'] == 0) { echo 'selected="selected"'; } ?>>Non</option>
			<option value="1" <?php if(isset($_POST['col']) && $_POST['col'] == 1) { echo 'selected="selected"'; } ?>>Oui</option>
		</select>
		<label for="col">Colorisation du code</label>
		</div>
		
		<div class="bloc">
		<select name="num">
			<option value="0" <?php if(isset($_POST['num']) && $_POST['num'] == 0) { echo 'selected="selected"'; } ?>>Non</option>
			<option value="1" <?php if(isset($_POST['num']) && $_POST['num'] == 1) { echo 'selected="selected"'; } ?>>Oui</option>
		</select>
		<label for="num">Numérotation des lignes</label>
		</div>
		
		<p id="bouton"><input type="submit" name="submit" value="Tester"/></p>
	</form>
</div>
	
<div id="resultat">
	<?php if(isset($_POST['submit']) && !empty(trim($_POST['url']))) {	?>
	<?php // Traitement des données
		$url = htmlspecialchars(trim($_POST['url']));
		$col = htmlspecialchars($_POST['col']);
		$num = htmlspecialchars($_POST['num']);
	?>
	<h2>Affichage pour l'adresse <?php echo $url; ?></h2>
	<p><?php spiderSimulator($url, $col, $num); ?></p>
	<?php } ?>
</div>
</body>
</html>